#include                <unistd.h>
#include                <string.h>
#include                <stdlib.h>
#include                <dlfcn.h>
#include                <time.h>
#include <stdio.h>
#include <sys/time.h>
#include <pthread.h>
#include		"tap.h"
#include		"libFireBird.h"
#include "TMSCommander.h"

#define PROGRAM_NAME	"Script"
#define VERSION			"V1.1"
#define D(x)			;

TAP_ID				(0x8E0Effff);
TAP_PROGRAM_NAME	(PROGRAM_NAME" "VERSION);
TAP_AUTHOR_NAME		("srupprecht & xyzzyx");
TAP_DESCRIPTION		("Executes start.sh and end.sh scripts");
TAP_ETCINFO			(__DATE__);

dword TAP_EventHandler(word event, dword param1, dword param2);
int TAP_Main(void);

static void call_end_sh(int param1)
{
	char buffer[64];
	sprintf(buffer, "sh /mnt/hd/ProgramFiles/end.sh %d", param1);
	system(buffer);
}

dword TAP_EventHandler(word event, dword param1, dword param2)
{
	(void) param2;

	if (event == EVT_STOP)
	{
		call_end_sh(param1);
		TAP_Exit(); //v1.1
	}
	else if (event == EVT_TMSCommander)
	{
		switch (param1)
		{
			case TMSCMDR_Capabilities:
				param1 = TMSCMDR_CanBeStopped;
			break;

			case TMSCMDR_Stop:
				call_end_sh(2);
				TAP_Exit();
				param1 = TMSCMDR_OK;
			break;

			default:
				param1 = TMSCMDR_UnknownFunction;
		}
	}
	
	return param1;
}

int TAP_Main(void)
{
	//system("chmod +x /mnt/hd/ProgramFiles/start.sh /mnt/hd/ProgramFiles/end.sh");
	system("sh /mnt/hd/ProgramFiles/start.sh");
	
	return 1;
}
